% TP2 S5 2023-2024 
% Resolution d'un systeme lineaire tridiagonal
% par les methodes LU, Jacobi et Gauss-Seidel

% choix de N et de la matrice
disp('Choix de la dimension du systeme');
N = input('N  = ');
disp('Choix de la matrice du systeme');
disp('1 : diagonale avec des 2 et sur- et sous-diagonale avec des -1');
disp('2 : diagonale avec des 4 et sur- et sous-diagonale avec des -1');
matrice = input('Choix : ');
% initialisation de A et b

if (matrice == 1)
    A = (2*eye(N) - diag(ones(1,N - 1), -1) - diag(ones(1,N - 1), 1));
    printf('cond_t(A) = %10.2e\n', (4/(pi*pi))*(N+1)*(N+1));  
else
    A = (4*eye(N) - diag(ones(1,N - 1), -1) - diag(ones(1,N - 1), 1));
end

b = ones(N,1);

% Conditionnement de la matrice A
printf('cond(A) = %10.2e\n', cond(A));  
%
% Resolution du syteme linaire par les differentes methodes
% par linsolve de Matlab
tic;
x = linsolve(A,b);
time_linsolve = toc;
printf('time_linsolve = %10.2e\n', time_linsolve);
%Calcul du rsidu relatif
Residu_linsolve = norm(A*x-b)/norm(b);
printf('Residu relatif linsolve = %10.2e\n', Residu_linsolve);

% par factorisation LU
tic;
x = lu_tridiag(N, A,b);
time_lu = toc;
printf('time_lu = %10.2e\n', time_lu);
%Calcul du rsidu relatif
Residu_lu = norm(A*x-b)/norm(b);
printf('Residu relatif lu = %10.2e\n', Residu_lu);


% par Jacobi
tic;
[x,k,converge] = jacobi_tridiag(N, A,b, 100000, 5e-2);
time_jacobi = toc;
printf('time_jacobi = %10.2e\n', time_jacobi);
%Calcul du rsidu relatif
Residu_jacobi = norm(A*x-b)/norm(b);
printf('Residu relatif jacobi = %10.2e\n', Residu_jacobi);
printf("k = %d, converge = %d\n", k, converge);

% initialisation de la matrice d'iteration J et calcul de son rayon spectral
if (matrice == 1)
    J = (diag(ones(1,N - 1), -1) + diag(ones(1,N - 1), 1)) / 2;
else
    J = (diag(ones(1,N - 1), -1) + diag(ones(1,N - 1), 1)) / 4;
end

rho_J = norm(J, 2);
printf("rho(J) = %10.2e\n", rho_J);

% par Gauss-Seidel
tic;
[x,k,converge] = gauss_seidel_tridiag(N, A,b, 100000, 5e-2);
time_gs = toc;
printf('time_gs = %10.2e\n', time_gs);
%Calcul du rsidu relatif
Residu_gs = norm(A*x-b)/norm(b);
printf('Residu relatif gs = %10.2e\n', Residu_gs);
printf("k = %d, converge = %d\n", k, converge);
% calcul du rayon spectral de sa matrice d'iteration G (carre de rho(J))
rho_G = rho_J * rho_J;
printf("rho(G) = %10.2e\n", rho_G);




